<?

// ***********************************************************************
// *  Philips TV                                                         *
// *  Steuerungs API  V1.0                                               *
// *  Walter Knkel, 12.04.2012                                          *
// ***********************************************************************

// $host ist der einzige Parameter der angepasst werden mu

$host="192.168.178.30"; // IP-Adresse oder Name des Fernsehers

// Ab hier muss in der Regel nichts gendert werden **********************

function tv_getvolume()
{
	global $host;
	$url = "http://".$host.":1925/1/audio/volume";
	return(tv_befehl($url) ['current']);
}
function tv_getchannel()
{
	global $host;
	$url="http://".$host.":1925/1/channels/current";
	$prog_id=trim(tv_befehl($url) ['id']);
	$url="http://".$host.":1925/1/channels";
	$prog=formatText(trim(tv_befehl($url) [$prog_id] ['name']));
	return ($prog);
}
function tv_getchannellist()
{
	global $host;
	IF (Sys_ping($host,100))
	{
		$url = "http://".$host.":1925/1/channellists/tv_all";
		$cl=tv_befehl($url);
		$url = "http://".$host.":1925/1/channels";
		$cl_org=tv_befehl($url);
		$count=0;
		$text="";
		for ($count=0; $count < count($cl); $count++)
		{
			$id=$cl [$count];
			$num=$count+1;
			IF ($count<9)
			 {
			   $c1=$count+1;
			   $num="0".$c1;
			 }
			$liste[$count]=formatText($cl_org [$id] ['name']);
		}
		return($liste);
	}
	ELSE
	{
  	   echo "Fernseher nicht erreichbar zum Auslesen der URL";
	   return(FALSE);
	}
}
function tv_getname()
{
		global $host;
		$text= file_get_contents("http://".$host.":1925/1/system");
		$name=json_decode($text,TRUE);
		return($name['name']);
}
function tv_getversion()
{
		global $host;
		$text= file_get_contents("http://".$host.":1925/1/system");
		$name=json_decode($text,TRUE);
		return($name['softwareversion']);
}
function tv_getmodel()
{
		global $host;
		$text= file_get_contents("http://".$host.":1925/1/system");
		$name=json_decode($text,TRUE);
		return($name['model']);
}
function tv_getserialno()
{
		global $host;
		$text= file_get_contents("http://".$host.":1925/1/system");
		$name=json_decode($text,TRUE);
		return($name['softwareversion']);
}

function tv_setvolume($wert)
{
		$action=$wert;
		$url=2;
		return(tv_exec($url,$action));
}

function tv_digit($zahl)
{
		IF ($zahl <0 || $zahl >9 )
		   return(FALSE);
		$action='Digit'.$zahl;
		$url=0;
		return(tv_exec($url,$action));
}
function tv_volumedown()
{
		$action='VolumeDown';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_volumeup()
{
		$action='VolumeUp';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_source()
{
		$action='Source';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_subtitle()
{
		$action='Subtitle';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_teletext()
{
		$action='Teletext';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_viewmode()
{
		$action='Viewmode';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_back()
{
		$action='Back';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_record()
{
		$action='Record';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_rewind()
{
		$action='Rewind';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_fastforward()
{
		$action='FastForward';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_stop()
{
		$action='Stop';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_pause()
{
		$action='Pause';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_playpause()
{
		$action='PlayPause';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_adjust()
{
		$action='Adjust';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_info()
{
		$action='Info';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_home()
{
		$action='Home';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_confirm()
{
		$action='Confirm';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_previous()
{
		$action='Previous';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_next()
{
		$action='Next';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_find()
{
		$action='Find';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_standby()
{
		$action='Standby';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_options()
{
		$action='Options';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_mute()
{
		$action='Mute';
		$url=0;
		return(tv_exec($url,$action));
}

function tv_ambi_onoff()
{
		$action='AmbilightOnOff';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_ambi_expert()
{
		$action='expert';
		$url=1;
		return(tv_exec($url,$action));
}

function tv_ambi_manual()
{
		$action='manual';
 		$url=1;
		return(tv_exec($url,$action));
}
function tv_ambi_internal()
{
		$action='internal';
		$url=1;
		return(tv_exec($url,$action));
}
function tv_cursorright()
{
		$action='CursorRight';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_cursorleft()
{
		$action='CursorLeft';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_cursorup()
{
		$action='CursorUp';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_cursordown()
{
		$action='CursorDown';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_channeldown()
{
		$action='ChannelStepDown';
		$url=0;
		return(tv_exec($url,$action));
}

function tv_channelup()
{
		$action='ChannelStepUp';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_blue()
{
		$action='BlueColour';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_green()
{
		$action='GreenColour';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_yellow()
{
		$action='YellowColour';
		$url=0;
		return(tv_exec($url,$action));
}
function tv_red()
{
		$action='RedColour';
		$url=0;
		return(tv_exec($url,$action));
}

// ******************** Stammfunktionen ***************************************

function tv_befehl($url)
{
	global $host;
	IF (Sys_Ping($host,100))
		{
			$text = file_get_contents($url);
			$tv_arr=json_decode($text,TRUE);
		}
	ELSE
	{
	   echo "Fernseher nicht erreichbar zum Auslesen der URL";
		$tv_arr=FALSE;
	}
	return($tv_arr);
}

function tv_exec($url_type,$action)
{
		global $host;
		IF (Sys_Ping($host,100))
		{
		
			switch ($url_type)
			{
			case 0:
	  	      $state=array('key'=>$action);
	  	      $url="/input/key";
				break;
			case 1:
	  	   	$state=array('current'=>$action);
	  	   	$url="/ambilight/mode";
	  	   	break;
			case 2:
	  	   	$state=array('current'=>$action);
	  	   	$url="/audio/volume";
			   break;
			}
			$cu = curl_init('http://'.$host.':1925/1'.$url);
		  	curl_setopt($cu, CURLOPT_RETURNTRANSFER, 1);
	 		$json_state=json_encode($state);
			curl_setopt($cu, CURLOPT_POSTFIELDS,$json_state);
			$result=curl_exec($cu);
			curl_close($cu);
		}
		ELSE
		{
		   $result=FALSE;
	      echo "Fernseher nicht erreichbar zum Auslesen der URL";
		}
		return($result);
}
function formatText($text)
{
    $text = html_entity_decode($text);
    $text = str_replace("ö", "", $text);
    $text = str_replace("Ü", "", $text);
    $text = str_replace("ü", "", $text);
    $text = str_replace("ä", "", $text);
    $text = str_replace("ß", "", $text);
    $text = str_replace("&amp;ndash;", "-", $text);
    $text = str_replace('&amp;#039;', "`", $text);
    $text = str_replace("&amp;", "&", $text);
    $text = str_replace("Ö", "", $text);
    $text = str_replace("„", "\"", $text);
    $text = str_replace("“", "\"", $text);
    $text = str_replace("&ndash;", "-", $text);
    $text = str_replace("„", "\"", $text);
    $text = str_replace("", "\"", $text);
    $text = str_replace("", "\"", $text);
    $text = str_replace("", "-", $text);
    $text = str_replace("–", "-", $text);
    $text = str_replace("é", "", $text);
    $text = str_replace("Ä", "", $text);
    return $text;
}
?>